/********************************************************************************
 *                    Nonficker Vaxination
 *
 *
 *
 * Copyright (C) 2009  Felix Leder & Tillmann Werner
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * 
 *             contact {leder,werner}@cs.uni-bonn.de
 *
 *******************************************************************************/

#ifndef _MUTEX_H_
#define _MUTEX_H_

#define CONFICKER_VARIANT_A 1
#define CONFICKER_VARIANT_B 2
#define CONFICKER_VARIANT_C 3

#define MUTEX_CONST_PART 7
#define MUTEX_CONST_PART_C 0x63
#define MUTEX_PATTERN "Global\\%u-%u"
#define MAX_MUTEX 512

void create_random_char_string(unsigned char* buffer, int buffer_len);
int simplified_crc(unsigned char* computername, int computername_len);

char* startup_mutex(DWORD pid, DWORD conficker_variant);
DWORD mutex_code(DWORD conficker_variant);


#endif
