/********************************************************************************
 *               Conficker File & Registry Checker
 *
 *
 *
 * Copyright (C) 2009  Felix Leder & Tillmann Werner
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * 
 *             contact {leder,werner}@cs.uni-bonn.de
 *
 *******************************************************************************/


#ifndef _NAMEGEN_H_
#define _NAMEGEN_H_

#define CONFICKER_VARIANT_A 1
#define CONFICKER_VARIANT_B 2
#define CONFICKER_VARIANT_C 3


#define CONFICKER_B_DLLNAME_CONST 0x045419005
#define CONFICKER_C_DLLNAME_CONST 0x0C7BD45E1

#define CONFICKER_B_REGNAME_CONST 0x0B30AA17B
#define CONFICKER_C_REGNAME_CONST 0x0293BF4D3

int getDllName(unsigned char* buffer, int buffer_len, int variant);
int getRegRunKey(unsigned char* buffer, int buffer_len, int conficker_variant);
//void create_random_char_string(unsigned char* buffer, int buffer_len);

#endif
